#ifndef _HWDEINTPROP_H_
#define _HWDEINTPROP_H_

//#include <streams.h>

/* registry stuff */
#define HWDI_REG_KEY	HKEY_CURRENT_USER
#define HWDI_REG_SUBKEY	"Software\\GNU\\HWDI"
#define HWDI_REG_CLASS	"config"

#define REG_GET_N(X, Y, Z) size=sizeof(int);if(RegQueryValueEx(hKey, X, 0, 0, (LPBYTE)&Y, &size) != ERROR_SUCCESS) {Y=Z;}
#define REG_GET_S(X, Y, Z) size=MAX_PATH;if(RegQueryValueEx(hKey, X, 0, 0, Y, &size) != ERROR_SUCCESS) {lstrcpy(Y, Z);}
#define REG_SET_N(X, Y) RegSetValueEx(hKey, X, 0, REG_DWORD, (LPBYTE)&Y, sizeof(int))
#define REG_SET_S(X, Y) RegSetValueEx(hKey, X, 0, REG_SZ, Y, lstrlen(Y)+1)

typedef struct 
{
	int interlace;
	int vif_tff;
	int disp_mode;
	int use_imedia2;
	int am2_tff;
	int weave;
	int colorspace;
} CONFIG;

/* global */
extern CONFIG g_config;

/* functions */
void LoadRegistryInfo();
void SaveRegistryInfo();

interface IHWDeint : public IUnknown
{
};

class CHWDeintProp : public CBasePropertyPage
{
private:
	IHWDeint *m_pHWDeint;
public:
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT * phr);

	CHWDeintProp(LPUNKNOWN pUnk);
	~CHWDeintProp() {}

	HRESULT OnConnect(IUnknown *pUnk);
	HRESULT OnActivate(void);
	BOOL OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	HRESULT OnDisconnect(void);
};

#endif /* _HWDEINTPROP_H_ */
